#version 440 core

layout (location = 0) in vec3 vertex_position;
layout (location = 1) in vec3 vertex_normal;
layout (location = 2) in vec2 vertex_Uv;

out vec2 TexCoords;
out vec3 vertexNormal;
out vec3 fragPos;

// Fog items
out float visibility; 
const float fogDensity = 0.0010f;
const float gradient = 7.0f;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

varying float distToCamera;

void main()
{
    TexCoords = vertex_Uv;    
    gl_Position = projection * view * model * vec4(vertex_position, 1.0f);
	vertexNormal = vertex_normal;
	fragPos = vec3(model * vec4(vertex_position, 1.0f));
	
	// Cálculo de la variable 'visibility' que es la distancia entre este vértice y la posición de la cámara del jugador.
	// 'visibility' la usa el código de 'Fragment Shader' para saber cuanto de visible es cada pixel según su lejanía.
	distToCamera = gl_Position.w;	// Distancia desde la cámara hasta el vértice
	visibility = exp(-pow((distToCamera * fogDensity), gradient));
}